//+------------------------------------------------------------------+
//|                                                        CUSUM.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Abstract Mind."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green

//---- input parameters
extern int       periods=24;

//---- buffers
double ExtMapBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }


double average(int shift)
{
   double total =0;
   for(int i =0;i<periods;i++)
   {
      total += Close[i+shift];
   }
   if(periods>0)
      return(total/periods);
   return(0);   
}

int start()
  {
   int    counted_bars=IndicatorCounted();
   int limit;   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   
   for(int i=limit-1; i>=0; i--) {
      
      // avoid erroneos values
      if( MathAbs(ExtMapBuffer1[i+1]) >1000000)
         ExtMapBuffer1[i+1]=0;
      
      ExtMapBuffer1[i]= ExtMapBuffer1[i+1]+Close[i]-average(i);      
   }
   return(0);
  }
//+------------------------------------------------------------------+